# libtool.m4 - Configure libtool for the host system. -*-Autoconf-*-
## Copyright 1996, 1997, 1998, 1999, 2000, 2001, 2003, 2004
## Free Software Foundation, Inc.
## Originally by Gordon Matzigkeit <gord@gnu.ai.mit.edu>, 1996
##
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
##
## As a special exception to the GNU General Public License, if you
## distribute this file as part of a program that contains a
## configuration script generated by Autoconf, you may include it under
## the same distribution terms that you use for the rest of that program.
## Also Copyright Swarm Development Group
## November 2009

############################################################
# Hacked up from the old LT_AC_PROG_SED to find only       #
#  GNU sed                                                 #
#  Bill Northcott                                          #
#  November 2009                               #
############################################################
# WN_PROG_GSED
# --------------
# Check for a GNU sed program.
AC_DEFUN([WN_PROG_GSED],
[AC_MSG_CHECKING([for GNU sed for Swarm])
AC_CACHE_VAL(lt_cv_path_GSED,
[# Loop through the user's path and test for sed and gsed.
# Then use that list of sed's as ones to test for GNU.
as_save_IFS=$IFS; IFS=$PATH_SEPARATOR
for as_dir in $PATH
do
  IFS=$as_save_IFS
  test -z "$as_dir" && as_dir=.
  for lt_ac_prog in sed gsed; do
    for ac_exec_ext in '' $ac_executable_extensions; do
      if $as_executable_p "$as_dir/$lt_ac_prog$ac_exec_ext"; then
        lt_ac_gsed_list="$lt_ac_gsed_list $as_dir/$lt_ac_prog$ac_exec_ext"
      fi
    done
  done
done
lt_ac_max=0
lt_ac_count=0
# Add /usr/xpg4/bin/sed as it is typically found on Solaris
# along with /bin/sed that truncates output.
for lt_ac_gsed in $lt_ac_gsed_list /usr/xpg4/bin/sed; do
  test ! -f $lt_ac_gsed && break
  cat /dev/null > conftest.in
  lt_ac_count=0
  echo $ECHO_N "0123456789$ECHO_C" >conftest.in
  # Check for GNU sed and select it if it is found.
  AC_MSG_NOTICE([checking $lt_ac_gsed])
  if "$lt_ac_gsed" --version 2>&1 < /dev/null | grep 'GNU' > /dev/null; then
    lt_cv_path_GSED=$lt_ac_gsed
    break
  fi
done
])
GSED=$lt_cv_path_GSED
if test ! $GSED; then
  AC_MSG_ERROR(Please install GNU sed and ensure it is your PATH for configure.)
fi
])
